//+------------------------------------------------------------------+
//|                                                        |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, FX Sniper "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Tomato
#property indicator_color3 Yellow
#property indicator_color4 DeepPink

//---- buffers
//support
double Up[];
double Dn[];

//---- buffers
double ArrowUp[];
double ArrowDn[];

extern double K = 1; 
extern int Smooth = 10; 
int Nstat=3000;
extern datetime D0=D'01.01.2009';
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0, Up);      
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(1, Dn);      

   SetIndexStyle(2,DRAW_ARROW,0,2);
   SetIndexArrow(2, 233);        //   
   SetIndexBuffer(2, ArrowUp);      
   SetIndexLabel(2, "BUY");
   SetIndexEmptyValue(2, 0.0); 

   SetIndexStyle(3,DRAW_ARROW,0,2);
   SetIndexArrow(3, 234);        //   
   SetIndexBuffer(3, ArrowDn);   
   SetIndexLabel(3, "SELL");
   SetIndexEmptyValue(3, 0.0); 

   return(0);
  }

int start()

  {
      int counted_bars = IndicatorCounted(); 

      if (counted_bars < 0) return(-1); 
      if (counted_bars > 0) counted_bars--;
      
      //  
      Nstat = iBarShift(NULL,0,D0);
      
      int loopbegin = Bars - counted_bars;
      loopbegin = Nstat;
      
      double Brick, Up0, Dn0, BricksUp, BricksDn, lastB, lastS, Profit;
      bool noBuy, noSell;
      int ntot;
      
      ntot=0;     
      noBuy = true;
      noSell = true;
      lastB=0.0;
      lastS=0.0;
      Profit=0.0;
      
      Brick = K*iATR(NULL,0,Smooth,loopbegin);
      
      Up[loopbegin] = High[loopbegin];    
      Dn[loopbegin] = Low[loopbegin];
      Up[loopbegin+1] = High[loopbegin+1];    
      Dn[loopbegin+1] = Low[loopbegin+1];
      BricksUp = 0.0;
      BricksDn = 0.0;    

      int i;
      
      for(i = loopbegin; i >= 0; i--) {
         
         Up[i] = Up[i+1];
         Dn[i] = Dn[i+1];
         
         //  
         if(Close[i]>Up[i+1]+Brick) {
            if (Brick==0) { BricksUp = 0;} else { BricksUp = MathFloor(((Close[i]-Up[i+1])/Brick))*Brick; }
            Up[i] += BricksUp;
            Brick = K*iATR(NULL,0,Smooth,i);
            Dn[i] = Up[i] - Brick;
            BricksDn = 0;
         } 
         
         //  
         if(Close[i]<Dn[i+1]-Brick) {
            if (Brick==0) { BricksUp = 0;} else { BricksDn = MathFloor(((Dn[i+1] - Close[i])/Brick))*Brick; }
            Dn[i] -= BricksDn;
            Brick = K*iATR(NULL,0,Smooth,i);
            Up[i] = Dn[i] + Brick;
            BricksUp = 0;
         }
         
         // + 
         if (Up[i]>Up[i+1] && noBuy) {
            ArrowUp[i] = Close[i];
            noBuy = false;
            noSell = true;
            lastB = Close[i];
            if (lastS>0) {
               Profit += (lastS-lastB)/Point - 18;
               ntot++;
            }
         } else {
            ArrowUp[i] = 0;
         }
         
         
         if (Dn[i]<Dn[i+1] && noSell) {
            ArrowDn[i] = Close[i];
            noSell = false;
            noBuy = true;
            lastS = Close[i];
            if (lastB>0) {
               Profit += (lastS-lastB)/Point - 18;
               ntot++;
            }
         } else {
            ArrowDn[i] = 0;
         }
         
         //   
         if (i==0) {
            if (noSell) Profit += (Open[0]-lastB)/Point - 1.8;
            if (noBuy)  Profit += (lastS - Open[0])/Point - 1.8;
            ntot++;
         }
                
      }
      Comment("Nstat= " + Nstat + " Profit = " + DoubleToStr(Profit,2) + " Total = " + ntot + " Aver = " + DoubleToStr(Profit/ntot,2));
      return(0);
  }
//+------------------------------------------------------------------+



